# Copyright (C) 2021-2022. Logiciel élaboré par l'État, via la Drees.

# Pole Simulation du bureau Handicap et Dépendance, Drees.

# Ce programme informatique a été développé par la Drees. Il permet d'exécuter le modèle de microsimulation Autonomix version 1.0 de juillet 2022.

# Ce programme a été exécuté le 19/07/2022 avec la version 4.0.3 de R et les packages mobilisés sont listés dans le fichier DESCRIPTION du projet »

# La documentation du modèle peut être consultés sur [gitlab](https://drees_code.gitlab.io/public/modeles/autonomix/documentation-atnmxetablissement/description-datnmx-%C3%A9tablissement.html)

# Ce programme utilise les données de la base CARE Institution 2016

# Bien qu'il n'existe aucune obligation légale à ce sujet, les utilisateurs de ce programme sont invités à signaler à la DREES leurs travaux issus de la réutilisation de ce code, ainsi que les éventuels problèmes ou anomalies qu'ils y rencontreraient, en écrivant à DREES-CODE@sante.gouv.fr

# Ce logiciel est régi par la licence EUPL V1.2 soumise au droit français et européen, respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence EUPL V1.2, telle que diffusée sur https://eupl.eu/1.2/fr/ et reproduite dans le fichier LICENCE diffusé conjointement au présent programme.
# En contrepartie de l'accessibilité au code source et des droits de copie, de modification et de redistribution accordés par cette licence, il n'est offert aux utilisateurs qu'une garantie limitée. Pour les mêmes raisons, seule une responsabilité restreinte pèse sur l'auteur du programme, le titulaire des droits patrimoniaux et les concédants successifs.
# À cet égard l'attention de l'utilisateur est attirée sur les risques associés au chargement, à l'utilisation, à la modification et/ou au développement et à la reproduction du logiciel par l'utilisateur étant donné sa spécificité de logiciel libre, qui peut le rendre complexe à manipuler et qui le réserve donc à des développeurs et des professionnels avertis possédant des connaissances informatiques approfondies. Les utilisateurs sont donc invités à charger et tester l'adéquation du logiciel à leurs besoins dans des conditions permettant d'assurer la sécurité de leurs systèmes et ou de leurs données et, plus généralement, à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.


factor_table <- function(dataset, nb_modalites = 20){
  #' factor_table
  #'
  #' Convertit toutes les colonnes d'un data.frame en factor
  #'
  #' @param dataset data.frame dont on souhaite convertir les colonnes
  #' @param nb_modalites integer, nombre maximum de modalités pour chaque colonne

  p <- ncol(dataset)
  for (i in 1:p) {
    if (length(unique(dataset[[i]])) <= nb_modalites) {
      dataset[[i]] <- factor(dataset[[i]])
    }
  }
  return(dataset)
}


lancement_imputations_care <- function(chemin_donnees_construites_, nom_branche) {
  #' lancement_imputations
  #'
  #' Impute les valeurs manquantes des données issues de CARE-I pour la simulation.
  #'
  #' @param chemin_donnes_brutes_ character, chemin vers les données de CARE-I
  #' @param chemin_donnees_construites_ character, chemin où écrire les données consolidées
  #' @param nom_branche character, nom de la branche courante
  #'
  #' @export
  #'
  #' @importFrom readxl read_excel
  #' @importFrom dplyr rename mutate filter bind_rows group_by summarise left_join arrange select distinct case_when transmute ungroup
  #' @importFrom plyr mapvalues
  #' @importFrom VIM hotdeck
  #' @importFrom survey svyby svydesign svytable svytotal svymean
  #' @importFrom stats glm addmargins binomial median predict quantile
  #' @importFrom mice mice complete
  #' @importFrom class knn
  #' @importFrom lubridate time_length dmy interval
  #' @importFrom utils read.csv
  #' @importFrom magrittr %>%
  #' @importFrom stringr str_sub
  #' @importFrom descr freq

  chemin_constitution_ <- paste(chemin_donnees_construites_, '2-Constitution_bases',  nom_branche, sep = '/')
  chemin_imputation_ <- paste(chemin_donnees_construites_, "3-Imputations",  nom_branche, sep = "/")

  # TODO mettre dans paramètres années courante
  nb_als_seniors_foyer_annee_sim <-  106815 - 3090 # chiffres 2016 CNAF + estimation Autonomix LF
  nb_apl_seniors_foyer_annee_sim <- 118662 - 20062 # chiffres 2016 CNAF + estimation Autonomix LF


  #import de la table EHPA imputer précedemment
  load(paste(chemin_imputation_, "ett_10.RData", sep = '/'))


  # Import de la base Care-I ----------------------------------------------------------------------

  # Pour voir les statistiques descriptives de cette page se référer au document html StatistiquesDescriptivesCareI
  load(paste(chemin_constitution_, "care_i.RData", sep = '/'))
  summary(care_i)

  # On transforme les variables factorielles en facteurs
  p <- ncol(care_i)
  for (i in 1:p) {
    if (length(unique(care_i[[i]])) <= 20){
      care_i[[i]] <- factor(care_i[[i]])
    }
  }

  sum(care_i$POIDS_SENIOR.x) # 590418.8
  length(unique(care_i$IDETAB)) # 614

  # APPARIEMENT EHPA ET CARE ----------------------------------------------------------------
  load(paste(chemin_imputation_, "ett_10.RData", sep = '/'))
  load(paste(chemin_imputation_, "champtot5.Rdata", sep = '/'))

  print("Jointure CARE I et EHPA 2015 par finess répondant")
  # On joint la base care I à la base établissement par la clef du finess répondant
  # On rappelle qu'on a attribué un finess répondant grâce à un hotdeck aléatoire
  # stratifié aux établissements présents dans care-I pour chaque senior
  ett_10 <- ett_10 %>% dplyr::rename(finess_r = finess)

  care_i <- care_i %>% mutate(
    FINESS = as.character(FINESS)
    )

  care_i_1 <- left_join(care_i, champtot5, by = c( "FINESS")) # moche, patch
  care_i <- care_i_1 %>% left_join(ett_10,by="finess_r")

  # Verification de l'appariement -----------
  # finess_care <- unique(care_i_1$finess_r) # 626 finess répondants à EHPA dans Care
  # finess_ett <- unique(ett_9$finess_r) # choisis parmi 7497 finess repondants EHPA
  # length(intersect(finess_care, finess_ett)) # tous les finess répondants de EHPA dans
  # care se retrouvent bien dans la liste des finess répondants EHPA dans EHPA
  # setdiff(finess_care, finess_ett) # aucun probleme


  # Couple ---------------
  # table(care_i$TCCOUPLE) # 409 en couple - 2847 pas en couple - 6 sont a 9
  # sum(is.na(care_i$TCCOUPLE)) # 0 valeurs manquantes puisque elles st a 9

  # table(care_i$TCETATMATRI)
  # 1. Célibataire
  # 2. Pacsé(e)
  # 3. Marié(e)
  # 4. Veuf(ve)
  # 5. Divorcé(e)

  #dans imputation des revenus, les couples manquants sont mis à 0
  #car 5 sur 6 sont seuls dans RFS

  care_i <- care_i %>% mutate(TCCOUPLE_c = case_when(
    TCCOUPLE == 1 ~ 1,
    TCCOUPLE == 0 ~ 0,
    #TCETATMATRI == 2 | TCETATMATRI == 3 ~ 1,
    TRUE ~ 0
  ))

  # table(care_i$TCCOUPLE_c) # 409 en couple - 2853 pas en couple
  # sum(is.na(care_i$TCCOUPLE_c))

  care_i <- factor_table(care_i)

  # Nombre d'enfants -----------------------------------------------------------
  # on peut créer une variable : "a eu trois enfants ou plus" à partir de TCENF

  care_i <- care_i %>% mutate(i_3enfplus = factor(1*(as.numeric(as.character(TCENF))>=3)))
  # on impute ensuite à la médiane
  care_i$i_3enfplus[is.na(care_i$i_3enfplus)] <- median(as.numeric(as.character(care_i$i_3enfplus))
                                                        ,na.rm=TRUE)

  # Imputation Allocation Sociale à l'Hebergement ----------------------------------------
  #print("Imputation ASH")
  print("correction ASH")
  # proc_univariate_or_freq(care_i,care_i$ASH, "ASH")
  # Correction de la variable

  care_i <- care_i %>% mutate(ASH_c = case_when(
    ASH == 9 ~NA_integer_,
    ASH == 1 ~as.integer(1),
    ASH == 0 ~ as.integer(0),
    TRUE ~NA_integer_
  ))
  # On retransforme en factor:
  care_i$ASH_c <- factor(care_i$ASH_c)

  care_i <- care_i %>% mutate(ASH_c = case_when(
    !(is.na(ASH_c)) ~ASH_c,
    !(is.na(PRALLOC10)) ~PRALLOC10,
    TRUE ~ NA_integer_
  ))

  care_i <- care_i %>% mutate(TCCS_c = case_when(
    TCCS ==98 ~ NA_integer_,
    TCCS ==99 ~NA_integer_,
    !is.na(TCCS) ~ as.integer(as.character(TCCS)),
    TRUE ~ NA_integer_
  ))


  sum(is.na(care_i$TCCS_c))
  test <- care_i %>% filter( TCTRA=="0")
  sum(is.na(test$TCCS_c))

  care_i <- care_i %>% mutate(TCCS_c = case_when(
    is.na(TCCS_c) & TCTRA=="0" ~ "16",
    TRUE ~ as.character(TCCS_c)
  ))

  care_i$TCCS_c <- factor(care_i$TCCS_c)

  # Imputation diplôme -------------------------------------------------------

  care_i$TCDIPLOM <- factor(care_i$TCDIPLOM)
  # proc_univariate_or_freq(care_i,care_i$TCDIPLOM, nom_var = "TCDIPLOM")
  # 01. Aucun diplôme
  # 02. Certificat d’études primaires (CEP)
  # 03. BEPC, diplôme national du Brevet
  # 04. CAP ou CAP agricole, mention complémentaire au CAP
  # 05. BEP ou BEP agricole, mention complémentaire au BEP
  # 06. Autre diplôme ou titre professionnel de niveau CAP ou BEP
  # 07. Baccalauréat général (L, ES, S, A, B, C, D, E, philo., math-élem.,sciences-ex.) ou brevet supérieur
  # 08. Baccalauréat technologique (F, G, H, STT, STG, STI, SMS, ST2S, STI2D, agricole…)
  # 09. Baccalauréat professionnel y compris agricole
  # 10. Brevet professionnel (BP), brevet de technicien (BT), autre brevet de niveau baccalauréat
  # 11. Diplôme de la santé et du travail social de niveau baccalauréat (assistant dentaire, moniteur-éducateur, technicien d’intervention sociale et familiale…)
  # 12. Capacité en droit, DAEU, ESEU
  # 13. DEUG, PCEM, DUEL, DUES, certificat d’aptitude pédagogique (Bac +2)
  # 14. BTS, DUT, DEUST ou autre diplôme équivalent
  # 15. Diplôme des professions sociales et de la santé hors doctorat (assistant social, infirmier, éducateur spécialisé…)
  # 16. Diplôme ou titre professionnel de niveau bac+2
  # 17. Licence, licence professionnelle, maîtrise, master 1 (Bac +3 / +4)
  # 18. Diplôme d’une grande école de niveau bac+5 (ingénieur, commerce...)
  # 19. DEA, DESS, master professionnel, master recherche (Bac +5)
  # 20. Doctorat
  care_i <- care_i %>% mutate(TCDIPLOM_c = case_when(
    TCDIPLOM ==98 ~ NA_integer_,
    TCDIPLOM ==99 ~NA_integer_,
    !is.na(TCDIPLOM) ~ as.integer(as.character(TCDIPLOM)),
    TRUE ~ NA_integer_
  ))
  care_i$TCDIPLOM_c <- factor(care_i$TCDIPLOM_c)
  # proc_univariate_or_freq(care_i,care_i$TCDIPLOM_c, nom_var = "TCDIPLOM_c") # 652 valeurs manquantes

  # Secteur d'activité du dernier emploi -------------------------------------

  # proc_univariate_or_freq(care_i,care_i$TCSECT, nom_var = "TCSECT")
  # 01. Salarié(e) de l’État
  # 02. Salarié(e) d’une collectivité territoriale
  # 03. Salarié(e) d’une entreprise, d’un artisan, d’une association
  # 04. Salarié(e) d’un ou plusieurs particuliers
  # 05. Il (elle) aide un membre de sa famille dans son travail sans être rémunéré(e)
  # 06. Chef d’entreprise salarié(e), PDG, gérant(e) minoritaire, associé(e)
  # 07. Indépendant ou à son compte
  # 08. Salarié(e) des hôpitaux publics ou du secteur public social et médico-social

  care_i <- care_i %>% mutate(TCSECT_c = case_when(
    TCSECT ==98 ~ NA_integer_,
    TCSECT ==99 ~NA_integer_,
    !is.na(TCSECT) ~ as.integer(as.character(TCSECT)),
    TRUE ~ NA_integer_
  ))

  sum(is.na(care_i$TCSECT_c))
  test <- care_i %>% filter( TCTRA=="0")
  sum(is.na(test$TCSECT_c))

  care_i <- care_i %>% mutate(TCSECT_c = case_when(
    is.na(TCSECT_c) & TCTRA=="0" ~ "9",
    TRUE ~ as.character(TCSECT_c)
  ))
  table(care_i$TCSECT_c)
  care_i$TCSECT_c <- factor(care_i$TCSECT_c)

  # ALS : Attention il s'agit de la variable ALS de Care-I et non pas de EHPA
  # Ne pas confondre ces deux variable:
  # ALS dans Care-I : est ce que le senior touche l'ALS,
  # ALS_ehpa dans EHPA : est ce que l'établissement accueille des seniors qui touchent l'ALS
  # proc_univariate_or_freq(care_i_3, care_i_3$ALS, "ALS")
  # Correction de la variable ALS de Care
  care_i <- care_i %>% mutate(ALS_c = case_when(
    ALS == 9 ~NA_integer_,
    ALS == 1 ~as.integer(1),
    ALS == 0 ~ as.integer(0),
    TRUE ~NA_integer_
  ))
  care_i$ALS_c <- factor(care_i$ALS_c)

  # proc_univariate(care_i,"ALS_c","ALS_c") # 1107 NA
  # On complète avec pralloc9
  # proc_univariate_or_freq(care_i, care_i$PRALLOC9, "PRALLOC9")

  # data_mice <- care_i %>% select(ALS_c,PRALLOC9)
  # On regarde quand les deux sont manquants :
  # marginplot(data_mice, col = mdc(1:2))

  care_i <- care_i %>% mutate(ALS_I = case_when(
    !(is.na(ALS_c)) ~ALS_c,
    !(is.na(PRALLOC9)) ~PRALLOC9,
    TRUE ~ NA_integer_
  ))
  care_i$ALS_I <- factor(care_i$ALS_I)
  #freq(care_i$ALS_I,w=care_i$POIDS_SENIOR.x)
  # proc_univariate_or_freq(care_i,"ALS_I","ALS_I complétée par PRALLOC9") # 1077 manquants
  #proc_univariate_or_freq(care_i,"ALS_I","ALS_I pondérée complétée par PRALLOC9", weight = "POIDS_SENIOR.x")

  # Imputation de APL dans Care-I
  # De même Attention il s'agit de la variable APL de Care-I et non pas
  # des variables APL de EHPA CAPL et BENEF_APL
  # proc_univariate_or_freq(care_i, care_i$APL, "APL")
  # Correction de la variable APL
  care_i <- care_i %>% mutate(APL_c = case_when(
    APL == 9 ~NA_integer_,
    APL == 1 ~as.integer(1),
    APL == 0 ~ as.integer(0),
    TRUE ~NA_integer_
  ))
  # On retransforme en factor
  care_i$APL_c <- factor(care_i$APL_c)
  #freq(care_i$APL_c,w=care_i$POIDS_SENIOR.x)
  # proc_univariate_or_freq(care_i,  "APL_c", "APL_c ") # 1071 NA
  # proc_univariate_or_freq(care_i,  "APL_c", "APL_c pondérée  ", option = "no graph", weight = "POIDS_SENIOR.x")

  # proc_univariate_or_freq(care_i,  "APL_c","APL declarée par l'étab", weight = "POIDS_SENIOR.x")
  # proc_univariate_or_freq(care_i,  "ALS_c","ALS declarée par l'étab", weight = "POIDS_SENIOR.x")
  # proc_univariate_or_freq(care_i,  "PRALLOC8","APL declarée par senior", weight = "POIDS_SENIOR.x")
  # proc_univariate_or_freq(care_i,  "PRALLOC9","ALS declarée par senior", weight = "POIDS_SENIOR.x")
  # data_mice <- care_i %>% select(APL_c,PRALLOC8)
  # On regarde quand les deux sont manquants :
  # marginplot(data_mice, col = mdc(1:2))

  # On impute par PRALLOC8 quand c'est possible les valeurs manquantes de APL
  #on ne le fait pas pour ne pas augmenter le nombre de bénéficaires de l'APL
  # care_i <- care_i %>% mutate(APL_I = case_when(
  # !(is.na(APL_c)) ~APL_c,
  # !(is.na(PRALLOC8)) ~PRALLOC8,
  # TRUE ~ NA_integer_
  # ))
  # proc_univariate_or_freq(care_i, care_i$APL_I, "APL_I")
  care_i$APL_I <- care_i$APL_c
  data_mice <- care_i %>% select(APL_I,ALS_I)
  # On regarde quand les deux sont manquants :
  # marginplot(data_mice, col = mdc(1:2)) # 693 manquants communs


  # Comme une personne ne peut toucher les 2 aides en théorie
  # si on a l'info sur une alloc, on en déduit l'info sur l'autre
  # table("APL" = care_i$APL_I,"ALS"=care_i$ALS_I) #14 seniors touchent les 2
  # Correction des 14 seniors : on les mets à NA
  care_i$ALS_temp <- care_i$ALS_I
  care_i$APL_temp <- care_i$APL_I

  # On drevrait retrouver 1077+17 = 1094 NA pour ALS et 987+17 = 1004Na pour APL
  care_i <- care_i %>% mutate(ALS_temp = case_when(
    APL_I == 1 & ALS_I == 1 &!(is.na(APL_I)) & !(is.na(ALS_I)) ~ NA_integer_,
    TRUE ~ as.integer(as.character(ALS_I))
  ))
  care_i$ALS_temp <- factor(care_i$ALS_temp)


  care_i <- care_i %>% mutate(APL_temp = case_when(
    APL_I == 1 & ALS_I == 1 &!(is.na(APL_I)) & !(is.na(ALS_I)) ~ NA_integer_,
    TRUE ~ as.integer(as.character(APL_I))
  ))
  care_i$APL_temp <- factor(care_i$APL_temp)

  care_i$ALS_I <- care_i$ALS_temp
  care_i$APL_I <- care_i$APL_temp

  table(care_i$APL_I)
  table(care_i$ALS_I)
  sum(is.na(care_i$APL_I))
  # On continue d'imputer ALS en se disant que si le senior touche l'APL
  # alors il ne doit pas toucher l'ALS
  care_i <- care_i %>% mutate(ALS_I = case_when(
    !(is.na(ALS_I)) ~ as.character(ALS_I),
    APL_I==1  ~ "0",
    TRUE ~ NA_character_
  ))

  # De même on continue en parallele d'imputer APL en disant que si le
  # senior touche l'ALS alors il ne doit pas toucher l'APL

  care_i <- care_i %>% mutate(APL_I = case_when(
    !(is.na(APL_I)) ~as.character(APL_I),
    ALS_I==1  ~ "0",
    TRUE ~ NA_character_
  ))

  table(care_i$APL_I)
  table(care_i$ALS_I)
  # On retransforme en factor

  care_i$APL_I <- factor(care_i$APL_I)
  care_i$ALS_I <- factor(care_i$ALS_I)

  #Calcul d'une variable couple_rfs à partir des variables fiscales
  care_i <- care_i %>% mutate(couple_rfs = case_when(
    is.na(REV_IND_CONJ_I) ~ "0",
    !is.na(REV_IND_CONJ_I) ~ "1",
    TRUE ~ NA_character_
  ))
  table(care_i$couple_rfs,care_i$TCCOUPLE_c,useNA="always")
  class(care_i$couple_rfs)
  class(care_i$TCCOUPLE_c)

   table(care_i$MATRI_FOYER_FISC,useNA="always")
   table(care_i$MATRI_FOYER_FISC,care_i$couple_rfs,useNA="always")

  #Calcul des ressources APA en fonction des variables fiscales
  care_i <- care_i %>% mutate(ressource_apa_foyer_moy = (REV_IND_FOYER_I+REV_NONIND_FOYER_I)/12)
  summary(care_i$ressource_apa_foyer_moy)

  care_i <- care_i %>% mutate(ressource_apa_senior_moy = ifelse(
    couple_rfs=="0",
    ressource_apa_foyer_moy,
    ifelse(
      couple_rfs=="1",
      ressource_apa_foyer_moy/2,
      NA_real_
    )
  ))


  summary(care_i$ressource_apa_senior_moy)

  care_i <- care_i %>% mutate(senior_dec_2016=case_when(
    SENIOR_DECEDE_2016==1  ~ "oui",
    SENIOR_DECEDE_2016==0  ~ "non"
  ))

  #care_i <- care_i %>% dplyr::mutate(DATEDECES_2=as.Date(DATEDECES,format="%Y/%m/%d") )
  #care_i$yeardc <- lubridate::year(as.Date(care_i$DATEDECES))
  care_i$dddc <- lubridate::ymd(care_i$DATEDECES)

  care_i <- care_i %>% dplyr::mutate(duree_a_imp=case_when(
    SENIOR_DECEDE_2016==1  & !(IDSENIOR %in% c("1384_02","1506_02"))~ as.numeric(as.Date("2016/12/31",format="%Y/%m/%d")-(as.Date(dddc,format="%Y/%m/%d") )),
    IDSENIOR %in% c("1384_02","1506_02") ~ as.numeric(duree_a_imp_cj),
    TRUE  ~ NA_real_
  ))
  care_i <- care_i %>% dplyr::mutate(duree_vie_2016=case_when(
    SENIOR_DECEDE_2016==1  & !(IDSENIOR %in% c("1384_02","1506_02")) ~ as.numeric((as.Date(dddc,format="%Y/%m/%d") - as.Date("2016/01/01",format="%Y/%m/%d"))),
    IDSENIOR %in% c("1384_02","1506_02") ~ as.numeric(duree_vie_decla_2016),
    TRUE  ~ NA_real_
  ))

 tab<- table(care_i$TCCOUPLE_c,care_i$senior_dec_2016)
 tab<- table(care_i$senior_speciaux_2,care_i$senior_dec_2016,care_i$couple_rfs,useNA="always")
  addmargins(tab)

  #calcul des revenus annuels complets

  care_i <- care_i %>% mutate(
    senior_speciaux_2 <- as.character(senior_speciaux_2),
    REV_IND_SENIOR_I <- as.numeric(REV_IND_SENIOR_I),
    REV_IND_CONJ_I <- as.numeric(REV_IND_CONJ_I),
    REV_TOT_FOYER_I <- as.numeric(REV_TOT_FOYER_I),
    duree_vie_2016 <- as.numeric(duree_vie_2016)
    )

  care_i <- care_i %>% mutate(revenu_modele = case_when(
    senior_speciaux_2 %in% c("C décédé","D décédé","V décédé")
    ~ REV_TOT_FOYER_I/duree_vie_2016*365,
    senior_speciaux_2=="MV avec 2 decla - V pr senior - senior non décédé"
    ~ REV_TOT_FOYER_I+REV_IND_CONJ_I/duree_vie_decla_2016*duree_a_imp_cj,
    senior_speciaux_2=="MV avec 2 decla - V pr senior-senior décédé"
    ~ REV_TOT_FOYER_I+REV_IND_CONJ_I/duree_vie_decla_2016*duree_a_imp_cj
    +REV_IND_SENIOR_I/duree_vie_2016*duree_a_imp,
    senior_speciaux_2=="M avec 2 decla - senior décédé - V pr cj"
    ~ REV_TOT_FOYER_I+REV_IND_SENIOR_I/duree_vie_2016*duree_a_imp,
    senior_speciaux_2=="MV - 1 decla M -senior non décédé - imp AP"
    ~ REV_TOT_FOYER_I+REV_IND_CONJ_I/duree_vie_decla_2016*duree_a_imp_cj,
    senior_speciaux_2=="MV - 1 decla V -senior non décédé - imp AV"
    ~ REV_TOT_FOYER_I, #on ne peut rien pour le cj - pas de rev
    senior_speciaux_2=="M avec 1 decla - senior decede - V imputé pr cj"
    ~ REV_TOT_FOYER_I+REV_IND_SENIOR_I/duree_vie_2016*duree_a_imp,
    is.na(senior_speciaux_2) & senior_dec_2016=="oui" & couple_rfs==1
    ~ REV_TOT_FOYER_I+REV_IND_SENIOR_I/duree_vie_2016*duree_a_imp,
    is.na(senior_speciaux_2) & senior_dec_2016=="oui" & couple_rfs==0
    ~ REV_TOT_FOYER_I/duree_vie_2016*365,
    TRUE  ~ REV_TOT_FOYER_I,

  ))
  summary(care_i$revenu_modele)
  test<-care_i %>% filter(is.na(revenu_modele))
  test<-test %>% select(DATEDECES,duree_vie_2016,duree_a_imp,revenu_modele,dddc,senior_speciaux_2,senior_dec_2016,couple_rfs,  duree_vie_decla_2016,duree_a_imp_cj)
  test<-care_i %>% filter(IDSENIOR %in% c("1384_02","1506_02"))

  test<-care_i %>% filter(revenu_modele==Inf)
  test<-care_i %>% filter(revenu_modele>200000)
  test<-care_i %>% filter(revenu_modele!=REV_TOT_FOYER_I) #166
  freq(test$senior_speciaux_2)
  tab<-table(test$senior_speciaux_2,test$senior_dec_2016)
  addmargins(tab)

  #care_i$revenu_modele[care_i$revenu_modele==Inf]<-care_i$REV_TOT_FOYER_I[care_i$revenu_modele==Inf]
  #senior tel que le calcul donne infini ou très élevé car duree de vie =2 jours
   care_i$revenu_modele[care_i$IDSENIOR=="1459_02"]<-care_i$REV_TOT_FOYER_I[care_i$IDSENIOR=="1459_02"]
  care_i$revenu_modele[care_i$IDSENIOR=="1240_01"]<-care_i$REV_TOT_FOYER_I[care_i$IDSENIOR=="1240_01"]
  care_i$revenu_modele[care_i$IDSENIOR=="1328_01"]<-care_i$REV_TOT_FOYER_I[care_i$IDSENIOR=="1328_01"]

  #calcul des revenus annuels complets du senior
  care_i <- care_i %>% mutate(revenu_ind_senior_modele=case_when(
    senior_speciaux_2 %in% c("C décédé","D décédé","V décédé")
    ~ REV_IND_SENIOR_I*revenu_modele/REV_TOT_FOYER_I,
    senior_speciaux_2=="MV avec 2 decla - V pr senior - senior non décédé"
    ~ REV_IND_SENIOR_I,
    senior_speciaux_2=="MV avec 2 decla - V pr senior-senior décédé"
    ~ REV_IND_SENIOR_I+REV_IND_SENIOR_I/duree_vie_2016*duree_a_imp,
    senior_speciaux_2=="M avec 2 decla - senior décédé - V pr cj"
    ~ REV_IND_SENIOR_I+REV_IND_SENIOR_I/duree_vie_2016*duree_a_imp,
    senior_speciaux_2=="MV - 1 decla M -senior non décédé - imp AP"
    ~ REV_IND_SENIOR_I,
    senior_speciaux_2=="MV - 1 decla V -senior non décédé - imp AV"
    ~ REV_IND_SENIOR_I,
    senior_speciaux_2=="M avec 1 decla - senior decede - V imputé pr cj"
    ~ REV_IND_SENIOR_I+REV_IND_SENIOR_I/duree_vie_2016*duree_a_imp,
    is.na(senior_speciaux_2) & senior_dec_2016=="oui" & couple_rfs==1
    ~ REV_IND_SENIOR_I+REV_IND_SENIOR_I/duree_vie_2016*duree_a_imp,
    is.na(senior_speciaux_2) & senior_dec_2016=="oui" & couple_rfs==0
    ~ REV_IND_SENIOR_I*revenu_modele/REV_TOT_FOYER_I,
    TRUE  ~ REV_IND_SENIOR_I,

  ))
  summary(care_i$revenu_ind_senior_modele)
  test<-care_i %>% filter(revenu_ind_senior_modele>100000)#pas de problème

  #calcul des revenus annuels complets du conjoint
  care_i <- care_i %>% mutate(revenu_ind_conjoint_modele=case_when(
    senior_speciaux_2 %in% c("C décédé","D décédé","V décédé")
    ~ REV_IND_CONJ_I,
    senior_speciaux_2=="MV avec 2 decla - V pr senior - senior non décédé"
    ~ REV_IND_CONJ_I+REV_IND_CONJ_I/duree_vie_decla_2016*duree_a_imp_cj,
    senior_speciaux_2=="MV avec 2 decla - V pr senior-senior décédé"
    ~ REV_IND_CONJ_I+REV_IND_CONJ_I/duree_vie_decla_2016*duree_a_imp_cj,
    senior_speciaux_2=="M avec 2 decla - senior décédé - V pr cj"
    ~ REV_IND_CONJ_I,
    senior_speciaux_2=="MV - 1 decla M -senior non décédé - imp AP"
    ~ REV_IND_CONJ_I+REV_IND_CONJ_I/duree_vie_decla_2016*duree_a_imp_cj,
    senior_speciaux_2=="MV - 1 decla V -senior non décédé - imp AV"
    ~ REV_IND_CONJ_I, #on ne peut rien pour le cj - pas de rev
    senior_speciaux_2=="M avec 1 decla - senior decede - V imputé pr cj"
    ~ REV_IND_CONJ_I,
    TRUE  ~ REV_IND_CONJ_I,

  ))



 summary(care_i$revenu_ind_conjoint_modele)
 test<-care_i %>% filter(revenu_ind_conjoint_modele==Inf)
  care_i$revenu_ind_conjoint_modele[care_i$IDSENIOR=="1459_02"]<-care_i$REV_IND_CONJ_I[care_i$IDSENIOR=="1459_02"]
  care_i$revenu_ind_conjoint_modele[care_i$IDSENIOR=="1240_01"]<-care_i$REV_IND_CONJ_I[care_i$IDSENIOR=="1240_01"]
  care_i$revenu_ind_conjoint_modele[care_i$IDSENIOR=="1328_01"]<-care_i$REV_IND_CONJ_I[care_i$IDSENIOR=="1328_01"]

  #calcul des revenus non individualisable annuels complets pour les personnes seules
  care_i <- care_i %>% mutate(revenu_nonind_modele=case_when(
    senior_speciaux_2 %in% c("C décédé","D décédé","V décédé")
    ~ REV_NONIND_FOYER_I*revenu_modele/REV_TOT_FOYER_I,
    is.na(senior_speciaux_2) & senior_dec_2016=="oui" & couple_rfs==0
    ~ REV_NONIND_FOYER_I*revenu_modele/REV_TOT_FOYER_I,
    TRUE ~ REV_NONIND_FOYER_I))

  summary(care_i$REV_NONIND_FOYER_I)
  summary(care_i$revenu_nonind_modele)
  test<-care_i %>% filter(revenu_nonind_modele>350000)


  care_i <- care_i %>% mutate(ressource_apa_foyer = case_when(
    couple_rfs=="0" ~ (revenu_ind_senior_modele+revenu_nonind_modele)/12,
    couple_rfs=="1" ~ (revenu_ind_senior_modele+revenu_ind_conjoint_modele+revenu_nonind_modele)/12,
  ))
  summary(care_i$ressource_apa_foyer)
  test<-care_i%>% filter(ressource_apa_foyer>35000)
  test<-care_i%>% filter(IDSENIOR %in% c('1459_02',"1240_01","1328_01"))

  care_i <- care_i %>% mutate(ressource_apa_senior = case_when(
    couple_rfs=="0" ~ ressource_apa_foyer,
    couple_rfs=="1" ~ ressource_apa_foyer/2,
    TRUE ~ NA_real_
  ))
  summary(care_i$ressource_apa_senior)
  test <- care_i %>% filter(ressource_apa_senior!=ressource_apa_senior_moy) #166
  freq(test$senior_speciaux_2)
  tab<-table(test$senior_speciaux_2,test$senior_dec_2016)
  addmargins(tab)
  tab<-table(care_i$senior_speciaux_2,care_i$senior_dec_2016)
  addmargins(tab)

  sum(is.na(care_i$ressource_apa_senior))
  test <- care_i %>% filter(senior_speciaux_2=="MV avec 2 decla - V pr senior - senior non décédé")
  test<-test %>% filter(revenu_modele==REV_TOT_FOYER_I)

   care_i <- care_i %>% mutate(revenu_retr_senior_modele=case_when(
    senior_speciaux_2 %in% c("C décédé","D décédé","V décédé")
    ~ REV_RETR_SENIOR_I*revenu_modele/REV_TOT_FOYER_I,
    senior_speciaux_2=="MV avec 2 decla - V pr senior - senior non décédé"
    ~ REV_RETR_SENIOR_I,
    senior_speciaux_2=="MV avec 2 decla - V pr senior-senior décédé"
    ~ REV_RETR_SENIOR_I+REV_RETR_SENIOR_I/duree_vie_2016*duree_a_imp,
    senior_speciaux_2=="M avec 2 decla - senior décédé - V pr cj"
    ~ REV_RETR_SENIOR_I+REV_RETR_SENIOR_I/duree_vie_2016*duree_a_imp,
    senior_speciaux_2=="MV - 1 decla M -senior non décédé - imp AP"
    ~ REV_RETR_SENIOR_I,
    senior_speciaux_2=="MV - 1 decla V -senior non décédé - imp AV"
    ~ REV_RETR_SENIOR_I,
    senior_speciaux_2=="M avec 1 decla - senior decede - V imputé pr cj"
    ~ REV_RETR_SENIOR_I+REV_RETR_SENIOR_I/duree_vie_2016*duree_a_imp,
    TRUE  ~ REV_RETR_SENIOR_I,

  ))
  summary(care_i$revenu_retr_senior_modele)

  #calcul des revenus annuels complets du conjoint
  care_i <- care_i %>% mutate(revenu_retr_conjoint_modele=case_when(
    senior_speciaux_2 %in% c("C décédé","D décédé","V décédé")
    ~ REV_RETR_CONJ_I,
    senior_speciaux_2=="MV avec 2 decla - V pr senior - senior non décédé"
    ~ REV_RETR_CONJ_I+REV_RETR_CONJ_I/duree_vie_decla_2016*duree_a_imp_cj,
    senior_speciaux_2=="MV avec 2 decla - V pr senior-senior décédé"
    ~ REV_RETR_CONJ_I+REV_RETR_CONJ_I/duree_vie_decla_2016*duree_a_imp_cj,
    senior_speciaux_2=="M avec 2 decla - senior décédé - V pr cj"
    ~ REV_RETR_CONJ_I,
    senior_speciaux_2=="MV - 1 decla M -senior non décédé - imp AP"
    ~ REV_RETR_CONJ_I+REV_RETR_CONJ_I/duree_vie_decla_2016*duree_a_imp_cj,
    senior_speciaux_2=="MV - 1 decla V -senior non décédé - imp AV"
    ~ REV_RETR_CONJ_I, #on ne peut rien pour le cj - pas de rev
    senior_speciaux_2=="M avec 1 decla - senior decede - V imputé pr cj"
    ~ REV_RETR_CONJ_I,
    TRUE  ~ REV_RETR_CONJ_I,

  ))

  summary(care_i$revenu_retr_conjoint_modele)

  care_i$revenu_retr_conjoint_modele[care_i$IDSENIOR=="1459_02"]<-care_i$REV_RETR_CONJ_I[care_i$IDSENIOR=="1459_02"]
  care_i$revenu_retr_conjoint_modele[care_i$IDSENIOR=="1240_01"]<-care_i$REV_RETR_CONJ_I[care_i$IDSENIOR=="1240_01"]
  care_i$revenu_retr_conjoint_modele[care_i$IDSENIOR=="1328_01"]<-care_i$REV_RETR_CONJ_I[care_i$IDSENIOR=="1328_01"]
  summary(care_i$revenu_retr_conjoint_modele)


  care_i <- care_i %>% mutate(retraite_foyer_moy= case_when(
    couple_rfs=="0" ~ REV_RETR_SENIOR_I,
    couple_rfs=="1" ~ REV_RETR_SENIOR_I+REV_RETR_CONJ_I,
    TRUE ~ NA_real_
  ))
  summary(care_i$retraite_foyer_moy)

  care_i <- care_i %>% mutate(retraite_foyer= case_when(
    couple_rfs=="0" ~ revenu_retr_senior_modele,
    couple_rfs=="1" ~ revenu_retr_senior_modele+revenu_retr_conjoint_modele,
    TRUE ~ NA_real_
  ))
  summary(care_i$retraite_foyer)
  sum(is.na(care_i$retraite_foyer))

  care_i <- care_i %>% mutate(ressource_apa_I = ressource_apa_senior)
  summary(care_i$ressource_apa_I)

  summary(care_i$NBPROXTOT)
  care_i$nbprox_reel <- as.numeric(levels(care_i$NBPROXTOT))[care_i$NBPROXTOT]
  test<-care_i %>% select(NBPROXTOT,nbprox_reel)

  care_i <- care_i %>% mutate(proxy=  case_when(
    nbprox_reel==0 ~ 0,
    nbprox_reel >0 ~ 1,
    TRUE ~NA_real_
  ))


  table(care_i$proxy)
  sum(care_i$POIDS_SENIOR.x)


  # Création des variables années au dessus de 60, années au dessus de 60 au carré
  care_i <- care_i %>% mutate(age_plus60 = TCDAGESEN_C - 60,
                                     age_plus60_carre = age_plus60^2)


  care_i <- care_i %>% mutate(GIR_c = GIR)
  care_i$GIR_c[care_i$GIR_c == 9] <- NA


  # Pour le GIR, 311 valeurs manquantes, dont 165 pour le vivier de 897 seniors

  # Creation d'une variable de durée en établissement
  care_i <- care_i %>% mutate(ENTETB_c = dmy(paste("01", ENTETB2, sep = '')))
  # head(care_i$ENTETB_c)
  # max(care_i$ENTETB_c, na.rm = TRUE)
  fin_enquete <- dmy("31122016") # On met fin 2016 comme fin de l'enquete,
  # en fait il faudrait prendre la date de l'enquete pour ce senior
  care_i <- care_i %>% mutate(duree_etab =
                                       time_length(interval(start = ENTETB_c,
                                                                       end = fin_enquete), unit = "months"))

  # proc_univariate_or_freq(care_i,  "duree_etab")

  # Raison de l'entree en etablissement
  # Entrée en établissement en raison de votre état de santé ou de votre âge
  care_i <- care_i %>% mutate(TCENT1_c = 1*(TCENT1 == 1))

  # Correction des variables de restrictions
  care_i <- care_i %>% mutate(RAASS_c = case_when(
    RAASS == 8 | RAASS == 9 ~ NA_character_,
    RAASS == 1 ~ "aucune",
    RAASS == 2 ~ "quelques",
    RAASS == 3 ~ "beaucoup",
    RAASS == 4 ~ "nepeutpas"
  )) %>% mutate(RAASS_c = factor(RAASS_c))
  # proc_univariate_or_freq(care_i, care_i$RAASS_c, "RAASS_c")
  care_i <- care_i %>% mutate(RACOU_c = case_when(
    RACOU == 8 | RACOU == 9 ~ NA_character_,
    RACOU == 1 ~ "aucune",
    RACOU == 2 ~ "quelques",
    RACOU == 3 ~ "beaucoup",
    RACOU == 4 ~ "nepeutpas"
  )) %>% mutate(RACOU_c = factor(RACOU_c))
  # proc_univariate_or_freq(care_i, care_i$RAASS_c, "RAASS_c")
  care_i <- care_i %>% mutate(RAELI_c = case_when(
    RAELI == 8 | RAELI == 9 ~ NA_character_,
    RAELI == 1 ~ "aucune",
    RAELI == 2 ~ "quelques",
    RAELI == 3 ~ "beaucoup",
    RAELI == 4 ~ "nepeutpas"
  )) %>% mutate(RAELI_c = factor(RAELI_c))
  # proc_univariate_or_freq(care_i, care_i$RAELI_c, "RAELI_c")
  care_i <- care_i %>% mutate(RAHAB_c = case_when(
    RAHAB == 8 | RAHAB == 9 ~ NA_character_,
    RAHAB == 1 ~ "aucune",
    RAHAB == 2 ~ "quelques",
    RAHAB == 3 ~ "beaucoup",
    RAHAB == 4 ~ "nepeutpas"
  )) %>% mutate(RAHAB_c = factor(RAHAB_c))
  # proc_univariate_or_freq(care_i, care_i$RAHAB_c, "RAHAB_c")
  care_i <- care_i %>% mutate(RAMAN_c = case_when(
    RAMAN == 8 | RAMAN == 9 ~ NA_character_,
    RAMAN == 1 ~ "aucune",
    RAMAN == 2 ~ "quelques",
    RAMAN == 3 ~ "beaucoup",
    RAMAN == 4 ~ "nepeutpas"
  )) %>% mutate(RAMAN_c = factor(RAMAN_c))
  # proc_univariate_or_freq(care_i, care_i$RAMAN_c, "RAMAN_c")
  care_i <- care_i %>% mutate( RANOU_c = case_when(
    RANOU == 8 |  RANOU == 9 ~ NA_character_,
    RANOU == 1 ~ "aucune",
    RANOU == 2 ~ "quelques",
    RANOU == 3 ~ "beaucoup",
    RANOU == 4 ~ "nepeutpas"
  )) %>% mutate( RANOU_c = factor( RANOU_c))
  # proc_univariate_or_freq(care_i, care_i$ RANOU_c, " RANOU_c")
  care_i <- care_i %>% mutate(RATOI_c = case_when(
    RATOI == 8 | RATOI == 9 ~ NA_character_,
    RATOI == 1 ~ "aucune",
    RATOI == 2 ~ "quelques",
    RATOI == 3 ~ "beaucoup",
    RATOI == 4 ~ "nepeutpas"
  )) %>% mutate(RATOI_c = factor(RATOI_c))
  # proc_univariate_or_freq(care_i, care_i$RATOI_c, "RATOI_c")

  care_i <- care_i %>% mutate(APA_c = case_when(
    APA == 9 ~NA_integer_,
    APA == 1 | APA == 0 ~ as.integer(as.character(APA)),
    TRUE ~NA_integer_
  )) %>% mutate(APA_c = factor(APA_c))
  # proc_univariate_or_freq(care_i,"APA_c","APA_c")
  # proc_univariate_or_freq(care_i,"APA_c","APA_c", weight = "POIDS_SENIOR.x")
  # On fait une imputation simultanée en prenant le GIR dans les variables à imputer
  # avec les autres
  care_i$GIR_c <- factor(care_i$GIR_c)
  print("Imputation GIR, APA, duree etab et restrictions simultanément")

  #on crée 2 variable : bénéficier de l'APA etab et bénficier de l'APA DOM

  care_i$APA_c <-as.character(care_i$APA_c)
  # on impose gir 1 à 4 bénéficiaires APA
  # gir 5 et 6 non bénéficiaires
  table(care_i$GIR_c,care_i$APA_c)

  care_i <- care_i %>% mutate(APA_etab = case_when(
    type_etab =="- de 25 hors lf" | type_etab=="lf"~ "0",
    GIR_c == 1 & type_etab== "25 ou + hors lf" ~ "1",
    GIR_c == 2 &  type_etab== "25 ou + hors lf" ~ "1",
    GIR_c == 3 &  type_etab== "25 ou + hors lf" ~ "1",
    GIR_c == 4 &  type_etab== "25 ou + hors lf" ~ "1",
    GIR_c == 5 &  type_etab== "25 ou + hors lf"  ~ "0",
    GIR_c == 6 &  type_etab== "25 ou + hors lf"  ~ "0",
    is.na(GIR_c) &  type_etab== "25 ou + hors lf" ~ APA_c,
    TRUE ~NA_character_
  ))

  #table(care_i$APA_etab)
  #sum(is.na(care_i$APA_etab))
  #table(care_i$type_etab,care_i$APA_etab)

  #care_i <- care_i %>% mutate(APA_dom = case_when(
  # type_etab== "25 ou + hors lf" ~ "0",
  # type_etab =="- de 25 hors lf" & !(is.na(APA_c)) ~ APA_c,
  #   TRUE ~NA_character_
  #))

  #table(care_i$APA_dom)
  #sum(is.na(care_i$APA_dom))
  #table(care_i$type_etab,care_i$APA_dom)





  #base<-care_i%>%filter(!is.na(care_i$GIR_c))
  #base_w1 <- svydesign(ids = ~1, data = base,
  #                            weights = ~base$POIDS_SENIOR.x)
  #table <- svyby(~GIR_c, ~type_etab, base_w1, svytotal)


  care_i <- care_i %>% mutate(APA_dom = case_when(
    type_etab== "25 ou + hors lf" ~ "0",
    type_etab =="- de 25 hors lf" & !(is.na(APA_c)) & is.na(GIR_c)~ APA_c,
    GIR_c == 1 & type_etab== "- de 25 hors lf" ~ "1",
    GIR_c == 2 &  type_etab== "- de 25 hors lf" ~ "1",
    GIR_c == 3 &  type_etab== "- de 25 hors lf" ~ "1",
    GIR_c == 4 &  type_etab== "- de 25 hors lf" ~ "1",
    GIR_c == 5 &  type_etab== "- de 25 hors lf"  ~ "0",
    GIR_c == 6 &  type_etab== "- de 25 hors lf"  ~ "0",
    GIR_c == 1 & type_etab== "lf" ~ "1",
    GIR_c == 2 &  type_etab== "lf" ~ "1",
    GIR_c == 3 &  type_etab== "lf" ~ "1",
    GIR_c == 4 &  type_etab== "lf" ~ "1",
    GIR_c == 5 &  type_etab== "lf"  ~ "0",
    GIR_c == 6 &  type_etab== "lf"  ~ "0",
    TRUE ~NA_character_
  ))

  care_i$APA_etab <- as.factor(care_i$APA_etab)
  care_i$APA_dom <- as.factor(care_i$APA_dom)

  care_i$APA_c <- as.factor(care_i$APA_c)
  care_i$APA_etab <- as.factor(care_i$APA_etab)
  care_i$APA_dom <- as.factor(care_i$APA_dom)


  sum(is.na(care_i$APA_dom))

  sum(is.na(care_i$APA_etab))

  #table(care_i$type_etab,care_i$APA_dom)

  #care_i <- care_i %>% mutate(taux_apa_dom = case_when(
  # type_etab =="25 ou + hors lf" &  logements_foyers=="1" ~ 0,
  #type_etab=="lf" ~ 0.175,
  #type_etab =="- de 25 hors lf" ~ 0.616 ,
  #  TRUE ~NA_real_
  #))

  #tab1<-data.frame(x=factor(care_i$type_etab),y=care_i$taux_apa_dom)
  #tapply(tab1$y,tab1$x,mean, na.rm = TRUE)

  care_i_gir <- care_i %>% select(GIR_c,APA_etab,APA_dom,
                                         duree_etab,RAASS_c,RACOU_c, RAELI_c, RAHAB_c,
                                         RAMAN_c, RANOU_c, RATOI_c,proxy ,TCCOUPLE_c,
                                         TCSEXESEN, TCDAGESEN_C,categ_pr_GIR,taille_etab)

  # On impute les valeurs manquantes avec mice par imputation simultanée
  # eventuellement mettre les itérations à 10 :
  set.seed(234)
  mice_mod <- mice(care_i_gir,m =1, maxit = 10, print = T, vis = "monotone",
                         method = c(rep("cart",3), "pmm",rep("cart",7),"pmm", "","","","",""))
  # print(mice_mod)
  # multiply imputed dataset, when we print we get the
  # imputation method
  mice_output <- complete(mice_mod)
  care_i_gir <- mice_output

  # On ajoute les variables imputées à la base care_i

  care_i <- care_i %>% mutate(GIR_I =  factor(mice_output$GIR_c))%>%
    mutate(duree_etab_I =  mice_output$duree_etab)%>%
    mutate(APA_etab_I =  mice_output$APA_etab)%>%
    mutate(APA_dom_I =  mice_output$APA_dom)%>%
    mutate(RAASS_I = mice_output$RAASS_c)%>%
    mutate(RACOU_I =  mice_output$RACOU_c)%>%
    mutate(RAELI_I =  mice_output$RAELI_c)%>%
    mutate(RAHAB_I =  mice_output$RAHAB_c)%>%
    mutate(RAMAN_I =  mice_output$RAMAN_c)%>%
    mutate(RANOU_I =  mice_output$RANOU_c)%>%
    mutate(RATOI_I =  mice_output$RATOI_c)%>%
    mutate(proxy_I =  mice_output$proxy)

  care_i<-care_i %>% mutate(un=1)

   base_w1 <- svydesign(ids = ~1, data = care_i,
                                weights = ~care_i$POIDS_SENIOR.x)

  table <- svyby(~un, ~type_etab + APA_etab_I, base_w1, svytotal)
  table(care_i$ASH,care_i$type_etab)

  test<-care_i %>% filter(type_etab=="lf" & APA_dom_I==0 & GIR_I %in% c("1", "2", "3" ,"4"))
  sum(test$POIDS_SENIOR.x)




  table(care_i$APA_dom_I,care_i$ASH,care_i$type_etab)

  care_i<-care_i %>%
    mutate(age_tr =  as.factor(cut(TCDAGESEN_C, c(35,80,90,115), right = FALSE,
                                                         include.lowest = TRUE)))

  # pour comparer les bénéficiaires APA à ceux d'EHPA (= GIR 1 à 4)
  summary(care_i$TCDAGESEN_C)

  test <-care_i%>%filter(TCDAGESEN_C<60)

  table(care_i$age_tr)

  base_APA<-care_i%>%filter(care_i$APA_etab_I==1)

  base_w1 <- svydesign(ids = ~1, data = base_APA,
                               weights = ~base_APA$POIDS_SENIOR.x)
  total_gir <- svytotal(~GIR_I, base_w1)
  total_gir <- data.frame(total_gir)


  tab <- svytable(~TCSEXESEN  , base_w1)
  tab <- data.frame(tab)

  tab <- svytable(~age_tr  , base_w1)
  tab <- data.frame(tab)

  table <- svyby(~TCSEXESEN, ~age_tr, base_w1, svytotal)




  #test <- care_i %>%  filter( APA_dom_I==1)

  # care_i <- factor_table(care_i)
  summary(care_i$TCDAGESEN_C)
  care_i  <- care_i  %>% mutate(age_tranche = as.factor(cut(TCDAGESEN_C,c(49,75,80,85,90,95,120),
                                                                   right = FALSE,
                                                                   include.lowest = TRUE)))


  # base_w1 <- svydesign(ids = ~1, data = care_i,
  #                              weights = ~care_i$POIDS_SENIOR.x)
  # total_gir <- svytotal(~GIR_I, base_w1)
  # total_gir <- data.frame(total_gir)
  #
  #
  # base_w1 <- svydesign(ids = ~1, data = care_i,
  #                              weights = ~care_i$POIDS_SENIOR.x)
  # total_gir <- svytotal(~GIR_I, base_w1)
  # total_gir <- data.frame(total_gir)
  #
  #
  # base_APA<-care_i%>%filter(care_i$APA_etab_I==1)
  #
  # base_w1 <- svydesign(ids = ~1, data = base_APA,
  #                              weights = ~base_APA$POIDS_SENIOR.x)
  # total_gir <- svytotal(~GIR_I, base_w1)
  # total_gir <- data.frame(total_gir)
  #
  # base_w1 <- svydesign(ids = ~1, data = base_APA,
  #                              weights = ~base_APA$POIDS_SENIOR.x)
  # total_gir <- svytotal(~GIR_I, base_w1)
  # total_gir <- data.frame(total_gir)


  # #ressources
  # quant<-svyquantile(~RPTOT_c, base_w1, seq(0.1,1,by=0.1),ci=FALSE,na.rm=T)
  # quant
  # quant<-svyquantile(~RPTOT_I_init, base_w1, seq(0.1,1,by=0.1),ci=FALSE,na.rm=T)
  # quant

  # #champ EHPAD + USLD
  # base_simul_ehpad<-care_i %>% filter(categ_2 %in% c("EHPAD privés à but non lucratif","EHPAD publics non hospitaliers",
  #                                                           "EHPAD privés à but lucratif","EHPAD publics hospitaliers","USLD" ))
  # table(base_simul_ehpad$categ_pr_GIR)
  #
  # base_ehpad_w1 <- svydesign(ids = ~1, data = base_simul_ehpad,
  #                                    weights = ~base_simul_ehpad$POIDS_SENIOR.x)
  #
  # quant<-svyquantile(~ressource_apa_senior, base_ehpad_w1, seq(0.1,1,by=0.1),ci=FALSE,na.rm=T)
  # quant <-data.frame(quant)
  # quant<-svyquantile(~ressource_apa_I, base_ehpad_w1, seq(0.1,1,by=0.1),ci=FALSE,na.rm=T)
  # quant <-data.frame(quant)
  #
  #
  #
  # quant_type_lf<-svyby(~ressource_apa_I,~TCCOUPLE_c, base_ehpad_w1, svyquantile,quantiles= seq(0.1,1,by=0.1),ci=TRUE,vartype="ci")
  # quant_type_lf<-svyby(~ressource_apa_I,~ASH_c, base_ehpad_w1, svyquantile,quantiles= seq(0.1,1,by=0.1),ci=TRUE,vartype="ci")
  #
  #
  #
  # care_i_c <- care_i
  # base_simul_care_w1 <- svydesign(ids = ~1, data = care_i_c,
  #                                         weights = ~care_i_c$POIDS_SENIOR.x)
  # quant<-svyquantile(~ressource_apa_I, base_simul_care_w1, seq(0.1,1,by=0.1),ci=FALSE,na.rm=T)
  # quant <-data.frame(quant)
  #
  # care_i_ps <- care_i %>% filter(TCCOUPLE_c=="0")
  # base_simul_care_seules_w1 <- svydesign(ids = ~1, data = care_i_ps,
  #                                                weights = ~care_i_ps$POIDS_SENIOR.x)
  # quant<-svyquantile(~ressource_apa_I, base_simul_care_seules_w1, seq(0.1,1,by=0.1),ci=FALSE,na.rm=T)
  # quant <-data.frame(quant)


  care_i_2 <- care_i

  # On va éliminer des variables inutiles
  care_i_2 <- care_i_2 %>% select(-RATOI,-RATOI_c,-RAHAB,-RAHAB_c,
                                         -RANOU,-RANOU_c,-RAMAN,-RAMAN_c,
                                         -RAELI,-RAELI_c,-RACOU,-RACOU_c,
                                         -RAASS,-RAASS_c,
                                           -STATUT_ETAB,
                                         -starts_with('TCENT'),
                                         TCDANNEESEN, -GIR
                                         # ,
                                         # -RPTOTUT, - RPTOU, - RPTR
                                         )

  care_i_3 <- care_i_2

  # Recours aux aide au logement -------------------------------------------------------
  print("Imputation des allocations logement dans CARE I")
  # table(care_i_3$APL,care_i_3$ALS)

  # proc_univariate_or_freq(care_i_3,  "APL_I","APL_I") # 1039 NA
  # proc_univariate_or_freq(care_i_3,  "APL_I","APL_I ", weight = "POIDS_SENIOR.x")
  # proc_univariate_or_freq(care_i_3,  "ALS_I","ALS_I")
  # proc_univariate_or_freq(care_i_3,  "ALS_I","ALS_I ", weight = "POIDS_SENIOR.x")
  # table("APL" = care_i_3$APL_I,"ALS"=care_i_3$ALS_I)

  # On cree une variable recours aux aides au logement fondée sur ce qui est observé
  care_i_4 <- care_i_3 %>% mutate(recours_al = case_when(
    (APL_I == 1) ~as.integer(1),
    (ALS_I == 1)  ~as.integer(1),
    (APL_I == 0)&(ALS_I == 0) ~as.integer(0),
    TRUE ~NA_integer_
  ))
  care_i_4$recours_al <- factor(care_i_4$recours_al)

  #freq(care_i_4$recours_al,w=care_i_4$POIDS_SENIOR.x)
  # test<-care_i_4%>% filter(is.na(ALS_I))
  # proc_univariate_or_freq(care_i_4, "recours_al","recours_al") #12 54 NA
  # proc_univariate_or_freq(care_i_4, "recours_al","recours_al",weight = "POIDS_SENIOR.x")
  # table("recours" = care_i_4$recours_al,"ASH" = care_i_4$ASH_I)

  # Imputation de la variable recours_al ------------------------------------
  # On utilise comme variable d'imputation la proportion de bénéficiaires des allocations
  # logement dans l'établissement calculé à partir de EHPA, les variables APL et ALS, les
  # ressources APA imputées (c'est nécessaire trop de valeurs manquantes)
  # et l'ASH corrigée mais pas imputée

  care_i_4 <- care_i_4 %>% mutate(recours_al_I = case_when(
    !(is.na(recours_al)) ~ recours_al,
    ASH_c == 1 ~ as.integer(1), # SI le senior touche l'ASH il recourt aux aides au logement
    TRUE ~NA_integer_
  ))

  #freq(care_i_4$recours_al_I,w=care_i_4$POIDS_SENIOR.x)
  #care_i_4 <-care_i_4 %>% mutate(recours_al_I = case_when(
  # !(is.na(recours_al)) ~ recours_al,
  #ressource_apa_I>1250 ~ as.integer(0), # SI le senior a des ress_apa>1400 il n'a pas recourt aux aides au logement
  #TRUE ~NA_integer_
  #))

  # proc_univariate_or_freq(care_i_4, "recours_al_I", "recours") # 1122 NA
  # proc_univariate_or_freq(care_i_4, "recours_al_I","recours pondéré", weight = "POIDS_SENIOR.x")
  #  proc_univariate_or_freq(care_i_4, "APL_I","APL_I", weight = "POIDS_SENIOR.x")
  # proc_univariate_or_freq(care_i_4, "ALS_I","ALS_I", weight = "POIDS_SENIOR.x")
  # On calcule la proportion de recours aux AL en année de base d'après les chiffres de la CAF
  prop_recours_al_annee_base <- (nb_apl_seniors_foyer_annee_sim + nb_als_seniors_foyer_annee_sim)/
    (sum(care_i_4$POIDS_SENIOR.x))

  # Poids des seniors dont recours al est non manquant:
  nb_non_manquant_recours_al <- sum(care_i_4$POIDS_SENIOR.x[!(is.na(care_i_4$recours_al_I))])

  # Proportion de recours aux aides au logement parmi les non manquant
  prop_recours_al_non_manq <- sum(care_i_4$POIDS_SENIOR.x[care_i_4$recours_al_I == 1&
                                                          !(is.na(care_i_4$recours_al_I))])/nb_non_manquant_recours_al

  # Poids des seniors dont recours al est manquant
  nb_manquant_recours_al <- sum((care_i_4$POIDS_SENIOR.x[is.na(care_i_4$recours_al_I)]))

  # Proportion x de recours_al = 1 à imputer parmi les manquants
  prop_recours_al_manquant_annee_base <-
    (prop_recours_al_annee_base*(sum(care_i_4$POIDS_SENIOR.x))-
       nb_non_manquant_recours_al*prop_recours_al_non_manq)/nb_manquant_recours_al

  prob <- glm(recours_al_I ~ taux_AL_c + ressource_apa_I + ASH_c, data = care_i_4,
                     family = binomial(link = "probit"))
  care_i_4 <- care_i_4 %>% mutate(probs = predict(prob, newdata = ., type = "response"))

  # summary(prob)

  temp_df <- care_i_4 %>% filter(is.na(recours_al_I)) %>% arrange(desc(probs))
  temp_df <- temp_df %>% mutate(poids_som_cum = cumsum(POIDS_SENIOR.x))
  temp_df <- temp_df %>% mutate(poids_dif = poids_som_cum - prop_recours_al_manquant_annee_base*sum(POIDS_SENIOR.x))
  max_number_of_lines <- min(which(temp_df$poids_dif >=0))
  prob_limit <- temp_df$probs[max_number_of_lines]


  # Imputation de recours_al
  care_i_4 <- care_i_4 %>% mutate(recours_al_I = case_when(
    !(is.na(recours_al_I)) ~recours_al_I,
    probs >= prob_limit  ~ as.integer(1),
    TRUE ~ as.integer(0)
  ))

  # si recours_al= 0 et apl et als manquant alors apl_I et als_I=0
  care_i_4$APL_I <-as.numeric(as.character(care_i_4$APL_I))

  table(care_i_4$APL_I)
  care_i_4 <- care_i_4 %>% mutate(APL_II = case_when(
    !(is.na(APL_I)) ~ as.integer(APL_I),
    recours_al_I == 0 & (is.na(APL_I)) ~ as.integer(0),
    TRUE ~ NA_integer_
  ))
  care_i_4$APL_II <-as.factor(care_i_4$APL_II)

  care_i_4$ALS_I <-as.numeric(as.character(care_i_4$ALS_I))
  care_i_4 <- care_i_4 %>% mutate(ALS_II = case_when(
    !(is.na(ALS_I)) ~ as.integer(ALS_I),
    recours_al_I == 0 & (is.na(ALS_I)) ~ as.integer(0),
    TRUE ~ NA_integer_
  ))
  care_i_4$ALS_II <-as.factor(care_i_4$ALS_II)

  Test<- care_i_4 %>% filter((recours_al_I==0)&(is.na(APL_II)))
  Test<- care_i_4 %>% filter((recours_al_I==0)&(is.na(ALS_II)))

  #Test<- care_i_4 %>% filter(recours_al_I==0) 2761
  # table(Test$APL_II,Test$ALS_II)
  # proc_univariate_or_freq(care_i_4, "ALS_II","ALS_II ") #
  # proc_univariate_or_freq(care_i_4, "ALS_II", "ALS_II ",weight = "POIDS_SENIOR.x", option = "no graph")
  #  proc_univariate_or_freq(care_i_4, "APL_II", "APL_II")
  # proc_univariate_or_freq(care_i_4, "APL_II","APL_II", weight = "POIDS_SENIOR.x", option = "no graph")


  #table(care_i_4$recours_al_I)
  #sum(is.na(care_i_4$recours_al_I))
  #sum(care_i_4$POIDS_SENIOR.x[care_i_4$recours_al_I == 1])
  #table(care_i_4$ALS_II )
  #sum(is.na(care_i_4$ALS_II))
  #sum(care_i_4$POIDS_SENIOR.x[care_i_4$ALS_II == 1])
  #table(care_i_4$recours_al_I,care_i_4$ALS_II )

  #table(care_i_4$APL_II)
  #sum(is.na(care_i_4$APL_II))
  #table(care_i_4$recours_al_I,care_i_4$APL_II )
  #sum(care_i_4$POIDS_SENIOR.x[care_i_4$APL_II == 1])


  # si recours_al= 1 et als = 0 et apl manquant alors apl_I =1
  # si recours_al= 1 et als = 1 et apl manquant alors apl_I =0
  #cela donne trop d APL
  #test<-care_i_4 %>% filter(recours_al_I==1 & ALS_II==0)
  #table(test$APL_II)
  #sum(is.na(test$APL_II))


  care_i_4$APL_II <-as.numeric(as.character(care_i_4$APL_II))
  care_i_4 <- care_i_4 %>% mutate(APL_III = case_when(
    !(is.na(APL_II)) ~ as.integer(APL_II),
    recours_al_I == 1 & (is.na(APL_II)) & ALS_II==0 ~ as.integer(1),
    recours_al_I == 1 & (is.na(APL_II)) & ALS_II==1 ~ as.integer(0),
    TRUE ~ NA_integer_
  ))
  care_i_4$APL_III <-as.factor(care_i_4$APL_III)
  #table(care_i_4$APL_II)
  #sum(is.na(care_i_4$APL_II))


  # si recours_al= 1 et apl=0 et als manquant alors als =1
  # si recours_al= 1 et apl=1 et als manquant alors als =0
  #test<-care_i_4 %>% filter(recours_al_I==1 & APL_II==0)
  #table(test$ALS_II)
  #sum(is.na(test$ALS_II))


  care_i_4$ALS_II <-as.numeric(as.character(care_i_4$ALS_II))

  care_i_4 <- care_i_4 %>% mutate(ALS_III = case_when(
    !(is.na(ALS_II)) ~ as.integer(ALS_II),
    recours_al_I == 1 & (is.na(ALS_II)) & APL_II==0 ~ as.integer(1),
    recours_al_I == 1 & (is.na(ALS_II)) & APL_II==1 ~ as.integer(0),
    TRUE ~ NA_integer_
  ))
  care_i_4$ALS_III <-as.factor(care_i_4$ALS_III)
  table(care_i_4$ALS_III)
  #sum(is.na(care_i_4$ALS_II))

  #sum(care_i_4$POIDS_SENIOR.x[care_i_4$recours_al_I == 1])
  #test<-care_i_4 %>% filter(is.na(APL_II) & is.na(ALS_II))
  #sum(test$POIDS_SENIOR.x)
  #test<-care_i_4 %>% filter(APL_II==1)
  #sum(test$POIDS_SENIOR.x)
  #test<-care_i_4 %>% filter(ALS_II==1)
  #sum(test$POIDS_SENIOR.x)

  #sum(care_i_4$POIDS_SENIOR.x[care_i_4$recours_al_I == 1])
  #test<-care_i_4 %>% filter(is.na(APL_II) & is.na(ALS_II))
  #sum(test$POIDS_SENIOR.x)
  #test<-care_i_4 %>% filter(APL_II==1)
  #sum(test$POIDS_SENIOR.x)
  #test<-care_i_4 %>% filter(ALS_II==1)
  #sum(test$POIDS_SENIOR.x)

  #care_i_4$APL_II <-as.factor(care_i_4$APL_II)
  #care_i_4$ALS_II <-as.factor(care_i_4$ALS_II)
  # proc_univariate_or_freq(care_i_4, "ALS_III","ALS_III ")
  # proc_univariate_or_freq(care_i_4, "ALS_III", "ALS_III ",weight = "POIDS_SENIOR.x", option = "no graph")
  #  proc_univariate_or_freq(care_i_4, "APL_III", "APL_III")
  # proc_univariate_or_freq(care_i_4, "APL_III","APL_III", weight = "POIDS_SENIOR.x", option = "no graph")


  Test<- care_i_4 %>% filter((recours_al_I==1)&(is.na(APL_III))) # 128
  Test<- care_i_4 %>% filter((recours_al_I==1)&(is.na(ALS_III))) # 128

  #on va mettre en cohérence info care_i et EHPA
  #on cree une variable qui synthetise l'info sur les alloc
  care_i_4<- care_i_4 %>% mutate(info_al2 = case_when(
    FINESS==finess_r~as.character(info_al),
    TRUE ~ as.character("NSP") # ne sait pas
  ))
  #test<-care_i_4%>% filter(FINESS==finess_r)
  table(care_i_4$info_al2)
  table(care_i_4$info_al2, care_i_4$APL_III)
  table(care_i_4$info_al2, care_i_4$ALS_III)
  Test<- care_i_4 %>% filter(is.na(APL_III))
  table(Test$info_al2)
  Test<- care_i_4 %>% filter(is.na(ALS_III))
  table(Test$info_al2)


  care_i_4$APL_III <-as.numeric(as.character(care_i_4$APL_III))
  care_i_4$APL_IV <-care_i_4$APL_III

  care_i_4$ALS_III <-as.numeric(as.character(care_i_4$ALS_III))
  care_i_4$ALS_IV <-care_i_4$ALS_III

  care_i_4$APL_IV[care_i_4$info_al2=="ALS"& care_i_4$APL_III==1] <-0
  care_i_4$ALS_IV[care_i_4$info_al2=="ALS"& care_i_4$APL_III==1] <-1

  table(care_i_4$info_al2, care_i_4$APL_IV)
  table(care_i_4$info_al2, care_i_4$ALS_IV)


  #care_i_4$ALS_IV[care_i_4$info_al2=="APL"& care_i_4$ALS_III==1] <-0
  #care_i_4$APL_IV[care_i_4$info_al2=="APL"& care_i_4$ALS_III==1] <-1

  #table(care_i_4$info_al2, care_i_4$APL_IV)
  #table(care_i_4$info_al2, care_i_4$ALS_IV)


  care_i_4$APL_IV <-as.factor(care_i_4$APL_IV)
  care_i_4$ALS_IV <-as.factor(care_i_4$ALS_IV)

  # proc_univariate_or_freq(care_i_4, "ALS_IV","ALS_IV ")
  # proc_univariate_or_freq(care_i_4, "ALS_IV", "ALS_IV ",weight = "POIDS_SENIOR.x", option = "no graph")
  #  proc_univariate_or_freq(care_i_4, "APL_IV", "APL_IV")
  # proc_univariate_or_freq(care_i_4, "APL_IV","APL_IV", weight = "POIDS_SENIOR.x", option = "no graph")

  test<-care_i_4%>% filter(is.na(APL_IV))
  table(test$info_al2)
  test<-care_i_4%>% filter(is.na(ALS_III))
  table(test$info_al2)


  care_i_4$APL_IV[care_i_4$info_al2=="ALS"& is.na(care_i_4$APL_III)] <-0
  care_i_4$ALS_IV[care_i_4$info_al2=="ALS"&  is.na(care_i_4$APL_III)] <-1

  table(care_i_4$info_al2, care_i_4$APL_IV)
  table(care_i_4$info_al2, care_i_4$ALS_IV)

  test<-care_i_4%>% filter(is.na(APL_IV))
  table(test$info_al2)
  care_i_4$APL_IV <-as.factor(care_i_4$APL_IV)
  care_i_4$ALS_IV <-as.factor(care_i_4$ALS_IV)
  # proc_univariate_or_freq(care_i_4, "ALS_IV","ALS_IV ")
  # proc_univariate_or_freq(care_i_4, "ALS_IV", "ALS_IV ",weight = "POIDS_SENIOR.x", option = "no graph")
  #  proc_univariate_or_freq(care_i_4, "APL_IV", "APL_IV")
  # proc_univariate_or_freq(care_i_4, "APL_IV","APL_IV", weight = "POIDS_SENIOR.x", option = "no graph")


  # reste à imputer les 79 valeurs manquantes pour arriver au bon chiffre total de la CNAF
  #on utilise la meme methode que pour recours_al
  prop_APL <- nb_apl_seniors_foyer_annee_sim/(sum(care_i_4$POIDS_SENIOR.x))
  nb_non_manquant_apl <- sum(care_i_4$POIDS_SENIOR.x[!(is.na(care_i_4$APL_IV))])
  prop_apl_non_manq <- sum(care_i_4$POIDS_SENIOR.x[care_i_4$APL_IV == 1&!(is.na(care_i_4$APL_IV))])/nb_non_manquant_apl
  nb_manquant_apl <- sum((care_i_4$POIDS_SENIOR.x[is.na(care_i_4$APL_IV)]))

  #temp_df <- care_i_4 %>% filter(is.na(APL_II)) %>% filter(recours_al_I == 1)
  #nb_manquant_apl_recours1 <- sum(temp_df$poids_post_calage) #49 955



  prop_apl_manquant_annee_base <- (prop_APL*(sum(care_i_4$POIDS_SENIOR.x))  -
                                     prop_apl_non_manq*nb_non_manquant_apl)/nb_manquant_apl



  prob <- glm(APL_IV ~ CAPL_I + taux_APL + ressource_apa_I + ASH_c, data = care_i_4,
                     family = binomial(link = "probit"))
  #variable taux_als non significative, de même qua cAPL_II1
  care_i_4 <- care_i_4 %>% mutate(probs2 = predict(prob, newdata = ., type = "response"))
  # summary(prob)

  temp_df <- care_i_4 %>% filter(is.na(APL_IV)) %>% filter(recours_al_I == 1)%>%
    arrange(desc(probs2))
  temp_df <- temp_df %>% mutate(poids_som_cum = cumsum(POIDS_SENIOR.x))
  temp_df <- temp_df %>%
    mutate(poids_dif = poids_som_cum - prop_apl_manquant_annee_base*sum(POIDS_SENIOR.x))
  max_number_of_lines <- min(which(temp_df$poids_dif >=0))
  prob_limit <- temp_df$probs2[max_number_of_lines]

  # Imputation de APL
  care_i_4 <- care_i_4 %>% mutate(APL_V = case_when(
    !(is.na(APL_IV)) ~ APL_IV,
    recours_al_I == 1 & probs2 >= prob_limit  ~ as.integer(1),
    TRUE ~ as.integer(0)
  ))
  #  proc_univariate_or_freq(care_i_4, "APL_V","APL_V", option = "no graph")
  #proc_univariate_or_freq(care_i_4, "APL_V","APL_V" ,weight = "POIDS_SENIOR.x", option = "no graph")

  care_i_4$APL_V <- factor(care_i_4$APL_V)


  # ALS
  care_i_4 <- care_i_4 %>% mutate(ALS_V = case_when(
    !(is.na(ALS_IV))&!(is.na(APL_IV)) ~ ALS_IV,
    APL_V == 0 & recours_al_I == 1 ~ as.integer(1),
    TRUE ~ as.integer(0)
  ))
  care_i_4$ALS_V <- factor(care_i_4$ALS_V)
  #  proc_univariate_or_freq(care_i_4, "ALS_V","ALS_V", option = "no graph")
  # proc_univariate_or_freq(care_i_4, "ALS_V","ALS_V" ,weight = "POIDS_SENIOR.x", option = "no graph")
  #proc_univariate_or_freq(care_i_4, "APL_V","APL_V" ,weight = "POIDS_SENIOR.x", option = "no graph")
  # Cohérence finale
  # table("APL" = care_i_4$APL_V, "ALS" = care_i_4$ALS_V) # OK
  # table("APL" = care_i_4$APL_V, "CAPL" = care_i_4$CAPL_I) # Il reste les 111 de APL_c
  # table("APL" = care_i_4$APL_V, "recours" = care_i_4$recours_al_I) # OK
  # table("ALS" = care_i_4$ALS_V, "recours" = care_i_4$recours_al_I) # OK
  al <- 1*(care_i_4$APL_V==1 | care_i_4$ALS_V==1)
  # table("AL" = al, "recours" = care_i_4$recours_al_I)


  # On alloue à chaque individu une des 2 allocations
  care_i_4 <- care_i_4 %>% mutate(type_aide_logement = case_when(
    APL_V ==1 ~ "APL",
    ALS_V == 1  ~ "ALS",
    TRUE ~"aucune"
  ))
  care_i_4$type_aide_logement <- factor(care_i_4$type_aide_logement)
  # table(care_i_4$type_aide_logement)




  # Comparaison des info allocation logement pour les differentes sources  EHPA et CARE -----

  # on somme pour voir si au moins 1 pers touche l'ALS ou l'APL pour chaque etab de care
  # on a 572 établissements

  # verif <- care_i_4 %>% select(finess_r, APL, APL_c, APL_III, CAPL_II,
  #                                     ALS, ALS_c, ALS_II, ALS_ehpa_I,
  #                                     BENEF_APL_II, BENEF_ALS_I,CAPL_c)
  # verif <- verif %>% mutate(APL_c= as.numeric(as.character(APL_c)))
  # table(verif$APL_c)
  # verif <- verif %>% mutate(ALS_c= as.numeric(as.character(ALS_c)))
  # table(verif$ALS_c)

  # data <- verif %>%
  #   group_by(finess_r) %>% summarise(ALS_cadr= sum(ALS_c, na.rm = TRUE),
  #                                    APL_cadr=sum(APL_c, na.rm = TRUE))

  # on remet à 1 ou 0 : variable qui dit si etab declare au moins 1 pers qui touche APL ou ALS
  # dans care_i cadrage
  #data <- data %>% mutate(ALS_cadr_c = case_when(
  # ALS_cadr>= 1 ~as.integer(1),
  # ALS_cadr == 0 ~ as.integer(0),
  # TRUE ~NA_integer_
  #))
  #table(data$ALS_cadr_c) # 129 etab déclarent au moins 1 bénéficiaire ALS

  #data <- data %>% mutate(APL_cadr_c = case_when(
  # APL_cadr>= 1 ~as.integer(1),
  # APL_cadr == 0 ~ as.integer(0),
  # TRUE ~NA_integer_
  #))
  #table(data$APL_cadr_c) # 266 etab déclarent au moins 1 bénéficiaire APL

  # On va chercher CAPL pour les finess_r dans la table ett_9
  #ett_10 <- ett_9 %>% select(finess_r,CAPL_c,CAPL_II,ALS_ehpa_I)
  #data <- data %>% left_join(ett_10,by="finess_r")

  #table(data$APL_cadr_c,data$CAPL_II) # 86 etab qui ne sont pas conventionnés APL dans EHPA 2015
  # ont déclaré des bénéficiaires APL dans CARE-I (explication possible: temporalité)
  #table(data$ALS_cadr_c,data$ALS_ehpa_I) # Pas forcément de cohérence: explication:
  # il y a l'aspect hotdeck qui fait que l'étab déclarant dans EHPA n'est pas forcément celui du
  # senior dans Care-I
  # En outre il y a le probleme de temporalite 2015/2016

  # Dotation globale ----------------------------------------------
  care_i_4 <- care_i_4 %>% dplyr::rename(DG_IND = APAGLOB_I)
  # On n'a pas conservé la correction département répondant non répondant,
  # qui n'était pas pertinente ici

  # Ajout des dépenses de mutuelles ####
  care_i_4 <- care_i_4 %>%
    mutate(RPAMCC_A = RPAMCC * 12 * (RPAMCCUT == 1)+
             RPAMCC * 4 * (RPAMCCUT == 2)+
             RPAMCC * 2 * (RPAMCCUT == 3)+
             RPAMCC * (RPAMCCUT == 4)
    )

  levels_mutuelle <- c(0, 25, 50, 75, 100, 150)

  care_i_4 <- care_i_4 %>% mutate(RPAMCCTR_c = case_when(
    RPAMCCTR == 9 ~ NA_integer_,
    TRUE ~ as.integer(RPAMCCTR)
  ))

  # On va créer une variable RPTR_I qui est un tirage d'une variable uniforme dans la tranche de RPTR_c
  set.seed(123)
  care_i_4 <- care_i_4 %>%
    mutate(RPAMCCTR_I = case_when(
      is.na(RPAMCCTR_c) ~ NA_real_,
      RPAMCCTR_c == 1 ~ runif(length(RPAMCCTR_c == 1), levels_mutuelle[1], levels_mutuelle[2]),
      RPAMCCTR_c == 2 ~ runif(length(RPAMCCTR_c == 2),levels_mutuelle[2],levels_mutuelle[3] ),
      RPAMCCTR_c == 3 ~ runif(length(RPAMCCTR_c == 3),levels_mutuelle[3],levels_mutuelle[4] ),
      RPAMCCTR_c == 4 ~ runif(length(RPAMCCTR_c == 4),levels_mutuelle[4],levels_mutuelle[5] ),
      RPAMCCTR_c == 5 ~ runif(length(RPAMCCTR_c == 5),levels_mutuelle[5],levels_mutuelle[6] ),
      RPAMCCTR_c == 6 ~ levels_mutuelle[6] + rexp(length(RPAMCCTR_c == 6), rate = 0.01)),
      RPAMCCTR_I = RPAMCCTR_I * 12)

  summary(care_i_4$RPAMCC_A)
  summary(care_i_4$RPAMCCTR_I)

  care_i_4 <- care_i_4 %>%
    mutate(montant_mutuelle_care =
             case_when(RPAMC == 0 ~ 0,
                       RPAMC %in% c(1, 8, 9) & !is.na(RPAMCC_A) ~ RPAMCC_A,
                       RPAMC %in% c(1, 8, 9) & !is.na(RPAMCCTR_I) ~ RPAMCCTR_I),
           montant_mutuelle_care =
             case_when(is.na(montant_mutuelle_care) ~ mean(montant_mutuelle_care, na.rm=TRUE),
                       TRUE ~ as.double(montant_mutuelle_care)))

  # Adaptation des noms de colonne pour le calage dans le module de simulation
  care_i_4$gir_imput <- care_i_4$GIR_I
  care_i_4$SEXE_C <- care_i_4$TCSEXESEN
  care_i_4$poids_final_CARE5 <- care_i_4$POIDS_SENIOR.x
  care_i_4$ressource_apa <- care_i_4$ressource_apa_I

  # # Correction des ressources APA avec variable enquête ####
  # Plus besoin avec les ressources fiscales
  # # Si ressources APA négatives, complétion avec les ressources déclarées dans l'enquête ou 0 si manquant
  # care_i_4$ressource_apa_I[care_i_4$ressource_apa_I < 0] <- pmax(care_i_4$RPTOT_c[care_i_4$ressource_apa_I < 0], 0, na.rm = TRUE)

  summary(care_i_4$montant_mutuelle_care)


  # Définition de rev preli
   care_i_4 <- care_i_4 %>% mutate(rev_preli = case_when(is.na(zvalf) ~ 0,
                                                         TRUE ~ as.numeric(zvalf)))


   print("Sauvegarde finale de la table imputée")
  save(care_i_4, file = paste(chemin_imputation_, "care_i_4_exp.RData", sep = '/'))
  return(care_i_4)

}
